// ======================================================================
//
// mat_wu.h
// jeff grills
//
// copyright 1996 origin sytems inc
//
// ======================================================================

#ifndef MAT_WU_H
#define MAT_WU_H

// ======================================================================

class Palette;
namespace raster
{
	struct texture;
	struct solid_surface_desc;
}

#include "matdata.h"

// ======================================================================

class MaterialData_wu : public MaterialData
{
private:

	byte                       *clut;
	raster::texture            *tmap;
	raster::solid_surface_desc *surf;

	bool                        ignore;

private:

	void init(void);
	
public:

	MaterialData_wu(int r, int g, int b, int a);
	MaterialData_wu(const Pixel8 *bitmap, int width, int height, const Palette *pal, bool transparency, const Pixel8 *alpha);
	MaterialData_wu(int width, int height, int r, int g, int b, const Pixel8 *alpha);
	virtual ~MaterialData_wu(void);

	raster::texture            *getTmap(void) const;
	raster::solid_surface_desc *getSolidSurf(void) const;

	bool ignoreDraw() const;
};

// =====================================================================

inline bool MaterialData_wu::ignoreDraw(void) const
{
	return ignore;
}

inline raster::texture *MaterialData_wu::getTmap(void) const
{
	return tmap;
}

// ----------------------------------------------------------------------

inline raster::solid_surface_desc *MaterialData_wu::getSolidSurf(void) const
{
	return surf;
}

// =====================================================================

#endif
